#!/usr/bin/python
# -*- coding: UTF-8 -*-

# edit and mod by @lululla 20240912
from enigma import eTimer as Timer


def has_callback_attribute(timer):
    return hasattr(timer, "callback")


try:
    Timer().callback
except AttributeError:
    # eTimer has changed interface on DMM images
    class eTimer(object):
        def __init__(self):
            self._timer = Timer()

        def __getattr__(self, key):
            # if key == "callback" and not hasattr(self._timer, "callback"):
            if key == "callback" and not has_callback_attribute(self._timer):
                timeout = self._timer.timeout
                timeout.append = timeout.connect
                return timeout
            else:
                return getattr(self._timer, key)
else:
    eTimer = Timer
